import React, { Component } from 'react';
import PropTypes from 'prop-types';

function getTagType(type, mode) {
  if(mode && ['modal', 'inset'].indexOf(style) >= 0) {
    return mode;
  }
  var tagType = '';
  switch(type) {
    case 'success':
    case 'warning':
    case 'fault':
    case 'confirm-info':
    case 'confirm-question':
      tagType = 'modal';
      break;
    case 'nodata':
    default:
      tagType = 'inset';
      break;
  }
  return tagType;
}

function getStyleStr(size, w, h) {
  var strs = [];
  if(!w || w < 0) {
    w = size === 'large' ? 800 : size === 'small' ? 260 : 420;
  }
  if(h && h >= 0) {
    h = size === 'large' ? 650 : size === 'small' ? 200 : 380;
  }
  strs.push('width='+ w +'px;');
  strs.push('height='+ w +'px;');
  return strs.join('');
}

export default class InfoUtils extends Component {
  static propTypes = {
      ...ConfigProvider.propTypes,
      prefix: PropTypes.string,
      rtl: PropTypes.bool,
      /**
       * 参数说明：
       * 
       */
      type: PropTypes.oneOf(['nodata', 'success', 'warning', 'fault', 'confirm-info', 'confirm-question']),
      mode: PropTypes.oneOf(['inset', 'modal']),
      text: PropTypes.string,
      
      classNames: PropTypes.array,
      size: PropTypes.oneOf(['small', 'medium', 'large']),
      width: PropTypes.number,
      height: PropTypes.number,
      style: PropTypes.string,

      onConfirm: PropTypes.func,
      onCancel: PropTypes.func,
  };

  static defaultProps = {
      type: 'normal',
      text: '',
      size: 'medium',
      style: 'light',
      onConfirm: () => {},
  };

  onConfirm = e => {
      // this.button.blur();

      if (this.props.onConfirm) {
          this.props.onConfirm(e);
      }
  };

  onCancel = e => {
      // this.button.blur();

      if (this.props.onCancel) {
          this.props.onCancel(e);
      }
  }; 

  getComponent = tag => {
    if(tag == 'modal') {
      return (
        <div className="clear">
            <div>{ this.props.text }</div>
        </div>
      );

    } else {
      return (
        <div className="clear">
            <div>{ this.props.text }</div>
        </div>
      );

    }
      
  }

  getFooter() {
    return '';
  }

  render() {
      const {
          type,
          mode,
          className,
          size,
          width,
          height,
          style
      } = this.props;
      const style = ['light', 'dark'].indexOf(style) >= 0 ? style : 'light';

      const TagType = getTagType(type, mode);
      const styleStr = getStyleStr(size, width, height);
      const component = this.getComponent(TagType);
      const footer = this.getFooter();

      return (
          <div className={className.push(style).join('')} style={styleStr} onClick={this.onConfirm}>
              {component}
              {footer}
          </div>
      );
  }
}
